'by JulioNIB

Imports System ' basic imports
Imports GTA ' basic imports
Imports System.Windows.Forms ' needed to have access to "keys" enumeration, for example
Imports System.Drawing ' needed to handle colors referencing the color name, ex: myCar.color = System.Drawing.Color.Black

Public Class FusRoDah
    Inherits Script
	
	private bSOn as boolean = false
	private hkActivate, hkFusRoDah as int32
	private force as double = 0.5
	private effectAlpha as double = 0
	private waitTime as int16 = 500
	private aSet as animationset = new animationset("melee_counters")
	
    Public Sub New()
        Me.interval = 10
		
		If Settings.GetValueKey("hkActivate", "HotKeys", -1) = -1 Then Settings.SetValue("hkActivate", "HotKeys", Keys.f4)
		If Settings.GetValueKey("hkFusRoDah", "HotKeys", -1) = -1 Then Settings.SetValue("hkFusRoDah", "HotKeys", Keys.e)
		
		Settings.save
		
		hkActivate = Settings.GetValueKey("hkActivate", "HotKeys", Keys.f4)
		hkFusRoDah = Settings.GetValueKey("hkFusRoDah", "HotKeys", Keys.e)
    End Sub
	
	private sub msg(sMsg as string, time as int32)
		Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", sMsg, time, 1)
	end sub
	
    Private Sub keyDown(ByVal sender As Object, ByVal e As GTA.KeyEventArgs) Handles MyBase.KeyDown
		if e.key = hkActivate then
			bSOn = not bSOn
			
			if bSOn then
				msg("''Fus ro Dah'' enabled", 3000)
			else
				msg("''Fus ro Dah'' disabled", 3000)
			end if
		end if
		
		if bSOn andalso (e.key = hkFusRoDah) andalso not player.character.isDead andalso not player.character.isGettingUp andalso not  player.character.isGettingIntoAVehicle then
			PlaySound(".\Scripts\FusRoDahFiles\fdr1.wav")
		end if
    End Sub	
	Private Sub keyUp(ByVal sender As Object, ByVal e As GTA.KeyEventArgs) Handles MyBase.KeyUp
		if bSOn andalso (e.key = hkFusRoDah) andalso not player.character.isDead andalso not player.character.isGettingUp andalso not  player.character.isGettingIntoAVehicle then			
			player.character.invincible = true
			
			dim vecPos as vector3
			dim currVeh as vehicle = player.character.currentvehicle
			dim vL as vehicle()
			dim pL as ped()
			dim vecDir as vector3
			dim maxDist as double = 15 + force
			dim coef as double = 0
			dim oL as gta.object()
			dim ptfx as int32
			dim radius1, radius2, radius3 as vector3
			dim tmpDriver as ped = nothing
			
			oL = world.getallobjects
			
			vecDir = game.currentcamera.direction
			
			radius1 = player.character.position + vecDir '2
			radius2 = player.character.position + vecDir * 8 '8
			radius3 = player.character.position + vecDir * 20 '26
			
			if exists(currVeh) then
				wait(waitTime)
				native.function.call("BREAK_CAR_DOOR", currVeh, 4, false)
				native.function.call("SMASH_CAR_WINDOW", currVeh, 0)
				native.function.call("SMASH_CAR_WINDOW", currVeh, 1)
				native.function.call("SMASH_CAR_WINDOW", currVeh, 2)
				native.function.call("SMASH_CAR_WINDOW", currVeh, 3)
			else				
				if exists(game.defaultcamera) then						
					player.character.heading = game.currentcamera.heading 
					
					player.character.animation.play(aSet, "dodge_back", 1.0)
					
					wait(1000)
					
					if player.character.isragdoll then exit sub
					
					PlaySound(".\Scripts\FusRoDahFiles\fdr2.wav")
				end if
			
				vecDir = player.character.direction
			end if
			
			PlaySound(".\Scripts\FusRoDahFiles\fdr2.wav")
			
			vecPos = player.character.position			
			vecpos += vecDir
			
			vL = world.getvehicles(vecPos + vecDir * maxDist, maxDist)
			
			ptfx = native.function.call(of int32)("START_PTFX_ON_PED_BONE", "bang_dusty", player.character, 0, 1.0, 0, 0, 0, 0, bone.head, 1.0 * force)
			
			effectAlpha = 100
			
			for each v as vehicle in vL
				if exists(v) andalso _
				   ((v.position.distanceto(radius1) <= 2) orelse (v.position.distanceto(radius2) <= 8) orelse (v.position.distanceto(radius3) <= 26)) then
					coef = (maxDist - vecPos.distanceto(v.position))
					
					if coef < 1 then coef = 1
					
					v.applyforce((vector3.worldup * 2 + vecDir * coef), vector3.worldup)				
					
					if vecPos.distanceto(v.position) < 10 then
						native.function.call("SMASH_CAR_WINDOW", v, 0)
						native.function.call("SMASH_CAR_WINDOW", v, 1)
						native.function.call("SMASH_CAR_WINDOW", v, 2)
						native.function.call("SMASH_CAR_WINDOW", v, 3)
						
						native.function.call("BREAK_CAR_DOOR", v, 0, false)
						native.function.call("BREAK_CAR_DOOR", v, 1, false)
						native.function.call("BREAK_CAR_DOOR", v, 2, false)
						native.function.call("BREAK_CAR_DOOR", v, 3, false)
						native.function.call("BREAK_CAR_DOOR", v, 4, false)
						native.function.call("BREAK_CAR_DOOR", v, 5, false)						
					end if
					
					native.function.call("SET_VEHICLE_EXPLODES_ON_HIGH_EXPLOSION_DAMAGE", v, false)
					
					tmpDriver = v.getpedonseat(vehicleseat.driver)
					
					if exists(tmpDriver) andalso (tmpDriver <> player.character) then
						tmpDriver.task.clearall			
						tmpDriver.task.CruiseWithVehicle(v, 100.0, false)
					end if
				end if
			next
			
			pL = world.getpeds(vecPos + vecDir * maxDist, maxDist)
			
			for each p as ped in pL
				if exists(p) andalso (p <> player.character) andalso not p.isSittingInVehicle andalso _
				   ((p.position.distanceto(radius1) <= 6) orelse (p.position.distanceto(radius2) <= 8) orelse (p.position.distanceto(radius3) <= 26))  then
					p.task.clearall
					p.preventragdoll = false
					'p.forceragdoll(5000.0, true)
					p.euphoria.bodybalance.start(5000)
					
					if exists(p.currentvehicle) then
						p.task.clearall
						p.WillFlyThroughWindscreen = true
						native.function.call("SET_PED_FORCE_FLY_THROUGH_WINDSCREEN", p)					
					end if
					
					coef = (maxDist - vecPos.distanceto(p.position))
					
					if coef < 1 then coef = 1
					
					p.velocity = p.velocity + ((vector3.worldup / 4 + vecDir) * coef)
					p.applyforce(vector3.worldup, vector3.worldup)
					
					p.task.FleeFromChar(player.character, false, 5000)
				end if
			next
			
			for each o as gta.object in oL
				if exists(o) andalso (o.position.distanceto(vecPos + vecDir * maxDist) < maxDist) andalso native.function.call(of boolean)("IS_OBJECT_ON_SCREEN", o) then
					coef = (maxDist - vecPos.distanceto(o.position))
					
					if coef < 1 then coef = 1
					
					o.detach					
					o.applyforce((vector3.worldup * 2 + vecDir * coef), vector3.worldup)		
				end if
			next
			
			wait(200)
			
			for each p as ped in pL
				if exists(p) andalso (p <> player.character) andalso not p.isSittingInVehicle andalso _
				   ((p.position.distanceto(radius1) <= 6) orelse (p.position.distanceto(radius2) <= 8) orelse (p.position.distanceto(radius3) <= 26))  then
					if not p.isragdoll then p.die
				end if
			next
			
			wait(1000)
			
			native.function.call("stop_ptfx", ptfx)
			
			for each v as vehicle in vL
				if exists(v) andalso (v.position.distanceto(vecPos) <= 8) then
					native.function.call("SET_VEHICLE_EXPLODES_ON_HIGH_EXPLOSION_DAMAGE", v, true)
				end if
			next
			
			player.character.invincible = false
			
			force = 0.5
			
			waitTime = 500
		end if
	end sub
	
	Private Sub general_tick(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Tick
		if bSOn andalso game.iskeypressed(hkFusRoDah) andalso not player.character.isDead andalso not player.character.isGettingUp andalso not  player.character.isGettingIntoAVehicle then
			if waitTime > 0 then
				waitTime -= me.interval
			
				if waitTime < 0 then waitTime = 0
			end if
			
			force += 0.5
			
			if not player.character.isSittingInVehicle andalso not game.isgamekeypressed(gamekey.moveforward) andalso not game.isgamekeypressed(gamekey.movebackward) andalso _
			   not game.isgamekeypressed(gamekey.moveleft) andalso not game.isgamekeypressed(gamekey.moveright) then _
			   player.character.task.turnto(player.character.position + game.currentcamera.direction) 
		end if
	end sub
	
	Private Sub GraphicsEventHandler(ByVal sender As Object, ByVal e As GTA.GraphicsEventArgs) Handles mybase.PerFrameDrawing
		if not  bSOn then exit sub
		
		if effectAlpha > 0 then
			e.Graphics.DrawRectangle(game.resolution.width / 2, game.resolution.height / 2, game.resolution.width, game.resolution.height, Color.FromArgb(effectAlpha, 0, 100, 200))
			effectAlpha -= 10
		end if
		
		for c as double = 0 to force
			e.graphics.drawrectangle(game.resolution.width / 2, game.resolution.height - 50, 10 * c, 10, Color.FromArgb(100, 255, 0, 0))
		next
	end sub
	
	 Private Sub PlaySound(ByVal sFile)
        Try
			Dim Sound As New System.Media.SoundPlayer()

			Sound.SoundLocation = sFile
			Sound.Load()
			Sound.Play()
        Catch
        End Try
    End Sub
End Class